CREATE TABLE fnd_user_role_migration_done (
    COMPLETED_USER_ROLE_ID    NUMBER(18, 0) ,
    TARGET_ID                 VARCHAR2(1024),
    USER_NAME                 VARCHAR2(400) ,
    USER_ID                   NUMBER(18, 0) ,
    ROLE_ID                   NUMBER(18, 0) ,
    ROLE_COMMON_NAME          VARCHAR2(4000),
    OPERATION_TYPE            VARCHAR2(80)      NOT NULL,
    TARGET                    VARCHAR2(40)      NOT NULL,
    CREATION_DATE             TIMESTAMP(6)      NOT NULL,
    LAST_UPDATE_DATE          TIMESTAMP(6)      NOT NULL,
    LAST_UPDATED_BY           VARCHAR2(256)     NOT NULL,
    LAST_UPDATE_LOGIN         VARCHAR2(128) ,
    CREATED_BY                VARCHAR2(256)     NOT NULL,
    COMPLETED_USER_ROLE_ID    NUMBER(18, 0) ,
    USER_NAME                 VARCHAR2(400) ,
    USER_ID                   NUMBER(18, 0) ,
    ROLE_ID                   NUMBER(18, 0) ,
    ROLE_COMMON_NAME          VARCHAR2(4000),
    OPERATION_TYPE            VARCHAR2(80)      NOT NULL,
    TARGET                    VARCHAR2(40)      NOT NULL,
    CREATION_DATE             TIMESTAMP(6)      NOT NULL,
    LAST_UPDATE_DATE          TIMESTAMP(6)      NOT NULL,
    LAST_UPDATED_BY           VARCHAR2(256)     NOT NULL,
    LAST_UPDATE_LOGIN         VARCHAR2(128) ,
    CREATED_BY                VARCHAR2(256)     NOT NULL,
    TARGET_ID                 VARCHAR2(1024),
    CONSTRAINT pk_fnd_user_role_migration_done PRIMARY KEY (COMPLETED_USER_ROLE_ID, USER_ID, ROLE_ID, COMPLETED_USER_ROLE_ID, USER_ID, ROLE_ID)
);
